Modules/Seguridad/Routes/web.php
<?php
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix("seguridad")
    ->name("seguridad.")
    ->middleware(["auth"])
    ->group(function () {
        Route::controller(SeguridadController::class)->group(function () {
            Route::get("/usuarios", "usuarios")->name("usuarios");
            Route::get("/modulos", "modulos")->name("modulos");
            Route::get("/modulos/{modulo}/permisos", "permisos")->name(
                "modulos.permisos"
            );
        });

        Route::controller(RolesController::class)
            ->prefix("roles")
            ->name("roles.")
            ->group(function () {
                Route::get("/", "index")->name("list");
                Route::get("/create", "create")->name("create");
                Route::post("/store", "store")->name("store");
                Route::get("/edit/{rol}/edit", "edit")->name("edit");
            });
    });

Modules/Seguridad/Http/Controllers/RolesController.php
<?php

namespace Modules\Seguridad\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Seguridad\Entities\Modulo;
use Spatie\Permission\Models\Role;

class RolesController extends Controller
{

    public function __construct()
    {
        $this->middleware("permission:roles listar")->only(
            "index"
        );

        $this->middleware("permission:roles editar")->only(
            "edit"
        );

        $this->middleware("permission:roles crear")->only(
            "create"
        );
    }
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        $breadcrumbs = [
            ["link" => "home", "name" => "Inicio"],
            ["link" => "seguridad/roles", "name" => "Roles"],
            ["name" => "Listado"],
        ];
        return view("seguridad::roles.index", compact("breadcrumbs"));
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        $breadcrumbs = [
            ["link" => "home", "name" => "Inicio"],
            ["link" => "seguridad/roles", "name" => "Roles"],
            ["name" => "Nuevo rol"],
        ];

        return view("seguridad::roles.create", compact("breadcrumbs"));
    }

    /**
     * Show the form for editing the specified resource.
     * @param Role $role
     * @return Renderable
     */
    public function edit(Role $rol)
    {
        $breadcrumbs = [
            ["link" => "home", "name" => "Inicio"],
            ["link" => "seguridad/roles", "name" => "Roles"],
            ["name" => $rol->name],
            ["name" => "Edición"],
        ];
        return view("seguridad::roles.edit", compact("breadcrumbs", "rol"));
    }
}

Modules/Seguridad/Http/Livewire/Modulos/Create.php
<?php

namespace Modules\Seguridad\Http\Livewire\Modulos;

use Livewire\Component;
use Illuminate\Support\Str;
use Modules\Seguridad\Entities\Modulo;

class Create extends Component
{
    public $model_id, $nombre, $icono;
    public $editing = false;

    public function render()
    {
        return view("seguridad::livewire.modulos.create");
    }

    public function resetInputFields()
    {
        $this->model_id = "";
        $this->nombre = "";
        $this->icono = "";
        $this->resetValidation();
    }
    public function store()
    {
        $this->validate([
            "nombre" => "required",
            "model_id" => "unique:modulos,id",
            "icono" => "required",
        ]);

        Modulo::create([
            "nombre" => $this->nombre,
            "id" => $this->model_id,
            "icono" => $this->icono,
        ]);

        $this->resetInputFields();

        $this->emit('moduloStored'); 
    }

    public function updatedNombre($value)
    {
    $this->model_id = Str::slug($value);
    }
}

Modules/Seguridad/Http/Livewire/Modulos/Delete.php
<?php

namespace Modules\Seguridad\Http\Livewire\Modulos;

use Livewire\Component;
use Modules\Seguridad\Entities\Modulo;

class Delete extends Component
{
    public function render()
    {
        return view("seguridad::livewire.modulos.delete");
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($model_id)
    {
        Modulo::find($model_id)->delete();
        $this->emit("moduloDeleted");
    }
}

Modules/Seguridad/Http/Livewire/Modulos/Edit.php
<?php

namespace Modules\Seguridad\Http\Livewire\Modulos;

use Livewire\Component;
use Illuminate\Support\Str;
use Modules\Seguridad\Entities\Modulo;

class Edit extends Component
{
    public $model_id, $nombre, $icono;
    public $editing = false;

    protected $listeners = [
        "moduloEdit" => "edit",
    ];

    public function render()
    {
        return view("seguridad::livewire.modulos.edit");
    }

    public function resetInputFields()
    {
        $this->model_id = "";
        $this->nombre = "";
        $this->icono = "";
        $this->resetValidation();
    }

    public function edit(Modulo $modulo)
    {
        $this->model_id = $modulo->id;
        $this->nombre = $modulo->nombre;
        $this->icono = $modulo->icono;
    }
    public function update()
    {
        $this->validate([
            "nombre" => "required",
            "icono" => "required",
        ]);

        Modulo::find($this->model_id)->update([
            "nombre" => $this->nombre,
            "icono" => $this->icono,
        ]);

        //$this->resetInputFields();

        $this->emit("moduloUpdated");
    }
}

Modules/Seguridad/Http/Livewire/Modulos/Index.php
<?php

namespace Modules\Seguridad\Http\Livewire\Modulos;

use Livewire\Component;
use Modules\Seguridad\Entities\Modulo;

class Index extends Component
{
    protected $listeners = [
        "moduloStored" => '$refresh',
        "moduloUpdated" => '$refresh',
        "moduloDeleted" => '$refresh',
    ];

    public function render()
    {
        $modulos = Modulo::withCount("permissions")->get();
        return view("seguridad::livewire.modulos.index", compact("modulos"));
    }
}

Modules/Seguridad/Http/Livewire/Permisos/Create.php
<?php

namespace Modules\Seguridad\Http\Livewire\Permisos;

use Livewire\Component;
use Illuminate\Support\Str;
use Modules\Seguridad\Entities\Permission;

class Create extends Component
{
    public $modulo_id;

    public $name,
        $label,
        $guard = "web";

    public function render()
    {
        return view("seguridad::livewire.permisos.create");
    }
    public function mount($modulo_id)
    {
        $this->modulo_id = $modulo_id;
    }

    public function resetInputFields()
    {
        $this->name = "";
        $this->label = "";
        $this->resetValidation();
    }
    public function store()
    {
        $this->validate([
            "name" => "required|unique:permissions",
            "label" => "required",
            "guard" => "required",
        ]);

        Permission::create([
            "name" => trim($this->name),
            "label" => trim($this->label),
            "modulo_id" => $this->modulo_id,
            "guard_name" => $this->guard,
        ]);

        $this->resetInputFields();

        $this->emit("permisoStored");
    }

    public function updatedLabel($value)
    {
        $name = $this->modulo_id . " " . $value;
        $this->name = Str::of($name)
            ->ascii()
            ->lower();
    }
}

Modules/Seguridad/Http/Livewire/Permisos/Delete.php
<?php

namespace Modules\Seguridad\Http\Livewire\Permisos;

use Livewire\Component;
use Modules\Seguridad\Entities\Permission;

class Delete extends Component
{
    public function render()
    {
        return view('seguridad::livewire.permisos.delete');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($model_id)
    {
        Permission::find($model_id)->delete();
        $this->emit("permisoDeleted");
    }
}

Modules/Seguridad/Http/Livewire/Permisos/Edit.php
<?php

namespace Modules\Seguridad\Http\Livewire\Permisos;

use Livewire\Component;
use Illuminate\Support\Str;
use Modules\Seguridad\Entities\Permission;
use Illuminate\Validation\Rule;

class Edit extends Component
{
    public $model_id,
        $name,
        $label,
        $guard = "web";

    protected $listeners = [
        "permisoEdit" => "edit",
    ];

    public function render()
    {
        return view("seguridad::livewire.permisos.edit");
    }
    public function mount($modulo_id)
    {
        $this->modulo_id = $modulo_id;
    }

    public function resetInputFields()
    {
        $this->name = "";
        $this->label = "";
        $this->resetValidation();
    }
    public function edit(Permission $permiso)
    {
        $this->model_id = $permiso->id;
        $this->name = $permiso->name;
        $this->label = $permiso->label;
        $this->guard = $permiso->guard_name;
    }
    public function store()
    {
        $this->validate([
            "name" => [
                "required",
                Rule::unique("permissions")->ignore($this->model_id),
            ],
            "label" => "required",
            "guard" => "required",
        ]);

        Permission::find($this->model_id)->update([
            "name" => trim($this->name),
            "label" => trim($this->label),
            "guard_name" => $this->guard,
        ]);

        $this->resetInputFields();

        $this->emit("permisoUpdated");
    }

    public function updatedLabel($value)
    {
        $name = $this->modulo_id . " " . $value;
        $this->name = Str::of($name)
            ->ascii()
            ->lower();
    }
}

Modules/Seguridad/Http/Livewire/Permisos/Index.php
<?php

namespace Modules\Seguridad\Http\Livewire\Permisos;

use Livewire\Component;
use Modules\Seguridad\Entities\Modulo;
use Modules\Seguridad\Entities\Permission;

class Index extends Component
{
    public $modulo_id;

    protected $listeners = [
        "permisoStored" => '$refresh',
        "permisoUpdated" => '$refresh',
        "permisoDeleted" => '$refresh',
    ];

    public function render()
    {
        $permisos = Permission::where("modulo_id", $this->modulo_id)->get();
        return view("seguridad::livewire.permisos.index", compact("permisos"));
    }

    public function mount($modulo_id)
    {
        $this->modulo_id = $modulo_id;
    }
}

Modules/Seguridad/Http/Livewire/Roles/Create.php
<?php

namespace Modules\Seguridad\Http\Livewire\Roles;

use Livewire\Component;
use Modules\Seguridad\Entities\Modulo;
use Modules\Seguridad\Entities\Permission;
use Modules\Seguridad\Entities\Role;
use Illuminate\Validation\Rule;

class Create extends Component
{
    public $permisos = [];
    public $isSelectedAll = false;
    public $totalPermisos = 0;
    public $allPermisos = [];
    public $checks = [];
    public $allChecksTrue = [];
    public $allChecksFalse = [];
    public $modulos = [];

    public $name,
        $guard = "web",
        $model_id;

    public function render()
    {
        return view("seguridad::livewire.roles.create");
    }

    public function mount($rol = null)
    {
        $this->modulos = Modulo::with("permissions")->orderBy('orden')->get();
        $this->allPermisos = Permission::pluck("id")->toArray();
        $this->totalPermisos = count($this->allPermisos);

        $ids = $this->modulos->pluck("id")->toArray();
        $this->checks = array_fill_keys($ids, false);
        $this->allChecksFalse = $this->checks;
        $this->allChecksTrue = array_fill_keys($ids, true);

        if (isset($rol)) {
            $this->model_id = $rol->id;
            $this->name = $rol->name;
            $this->guard = $rol->guard_name;
            $permisos = $rol->permissions()->get();
            $this->permisos = $permisos->pluck("id")->toArray();

            #activar los modulos que almenos un permiso activo
            $modulos = $permisos->pluck("modulo_id", "modulo_id");
            foreach ($modulos as $modulo) {
                $this->checks[$modulo] = true;
            }

            $this->updatedPermisos();
        }
    }

    public function store()
    {
        $this->validate([
            "name" => [
                "required",
                Rule::unique("roles")->ignore($this->model_id),
            ],
            "guard" => "required",
        ]);

        $role = Role::firstOrNew(["id" => $this->model_id]);
        $role->name = $this->name;
        $role->guard_name = $this->guard;
        $role->save();
        $role->syncPermissions($this->permisos);

        return redirect()->route("seguridad.roles.list");
    }

    public function updatedPermisos()
    {
        $this->isSelectedAll = count($this->permisos) == $this->totalPermisos;
    }

    public function addModulos()
    {
    }

    public function updatedIsSelectedAll($value)
    {
        if ($this->isSelectedAll) {
            $this->permisos = $this->allPermisos;
            $this->checks = $this->allChecksTrue;
        } else {
            $this->permisos = [];
            $this->checks = $this->allChecksFalse;
        }
    }

    public function removePermisos($permisos)
    {
        $this->permisos = array_values(
            array_unique(array_diff($this->permisos, $permisos))
        );
        $this->updatedPermisos();
    }
    public function addPermisos($permisos)
    {
        $this->permisos = array_values(
            array_unique(array_merge($this->permisos, $permisos))
        );
        $this->updatedPermisos();
    }
}

Modules/Seguridad/Http/Livewire/Roles/Delete.php
<?php

namespace Modules\Seguridad\Http\Livewire\Roles;

use Livewire\Component;
use Modules\Seguridad\Entities\Role;
use Modules\Seguridad\Entities\Permission;

class Delete extends Component
{
    public function render()
    {
        return view('seguridad::livewire.roles.delete');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($model_id)
    {
        Role::find($model_id)->delete();
        $this->emit("rolDeleted");
    }
}

Modules/Seguridad/Http/Livewire/Roles/Index.php
<?php

namespace Modules\Seguridad\Http\Livewire\Roles;

use Livewire\Component;
use Modules\Seguridad\Entities\Role;
use Livewire\WithPagination;

class Index extends Component
{
    use WithPagination;

    public $search;

    protected $queryString = ["search"];

    protected $listeners = [
        "rolStored" => '$refresh',
        "rolUpdated" => '$refresh',
        "rolDeleted" => '$refresh',
    ];

    public function updatingSearch()
    {
        $this->resetPage();
    }

    public function render()
    {
        $roles = Role::withCount('users')->where(
            "name",
            "like",
            "%" . $this->search . "%"
        )->paginate(10);
        return view("seguridad::livewire.roles.index", compact("roles"));
    }
}

Modules/Seguridad/Http/Livewire/Usuarios/Create.php
<?php

namespace Modules\Seguridad\Http\Livewire\Usuarios;

use App\Models\Team;
use App\Models\User;
use Livewire\Component;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\DB;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Hash;
use Modules\Organizacion\Entities\Colaborador;

class Create extends Component //$name,
{
    public $email,
        $username,
        $password,
        $colaborador_id = null;
    public $roles = [],
        $colaboradores = [];
    public $selectedRoles = [];
    public function resetInputFields()
    {
        //$this->name = "";
        $this->email = "";
        $this->username = "";
        $this->password = "";
        $this->selectedRoles = [];
        $this->colaborador_id = null;
        $this->resetValidation();
        $this->emit("setRoles", []);
        $this->emit("setColaborador", null);
    }
    public function store()
    {
        $this->validate([
            //"name" => "required",
            "username" => "required|unique:users",
            "password" => "required",
            "email" => "unique:users",
        ]);

        //$pass = Str::random(10);
        $pass = $this->password;
        DB::beginTransaction();

        $user = User::create([
            "name" => $this->username,
            "username" => $this->username,
            "email" => $this->email,
            "password" => Hash::make($pass),
            "colaborador_id" =>
                $this->colaborador_id > 0 ? $this->colaborador_id : null,
        ]);

        $user->syncRoles($this->selectedRoles);

        $this->createTeam($user);

        DB::commit();

        $this->resetInputFields();

        $this->emit("usuarioStored");
    }
    public function render()
    {
        return view("seguridad::livewire.usuarios.create");
    }

    public function mount()
    {
        $this->roles = Role::all();
        $this->colaboradores = Colaborador::all();
    }

    /**
     * Create a personal team for the user.
     *
     * @param  \App\Models\User  $user
     * @return void
     */
    protected function createTeam(User $user)
    {
        $user->ownedTeams()->save(
            Team::forceCreate([
                "user_id" => $user->id,
                "name" => explode(" ", $user->name, 2)[0] . "'s Team",
                "personal_team" => true,
            ])
        );
    }
}

Modules/Seguridad/Resources/views/livewire/roles/create.blade.php
<div>
    <div class="card">
        <div class="card-body">
            <!-- Add role form -->
            <div class="row gy-1">
                <div class="col-md-6">
                    <label class="form-label fw-bolder" for="name">Nombre del rol</label>
                    <input id="name" wire:model="name" type="text" name="name"
                        class="form-control @error('name') is-invalid @enderror" placeholder="Ingrese el nombre del rol"
                        tabindex="1" />
                    @error('name') <span class="invalid-feedback">{{ $message }}</span> @enderror
                </div>
                <div class="col-md-6">
                    <label class="form-label fw-bolder" for="guard">Guardian</label>
                    <input id="guard" wire:model="guard" type="text" name="guard"
                        class="form-control @error('guard') is-invalid @enderror"
                        placeholder="Ingrese el nombre del guardian" tabindex="-1" />
                    @error('guard') <span class="invalid-feedback">{{ $message }}</span> @enderror
                </div>
                <div class="col-md-6">
                    <div class="form-check form-switch">
                        <input wire:model="isSelectedAll" type="checkbox" class="form-check-input" id="all-permissions">
                        <label class="form-check-label fw-bolder" for="all-permissions">Selecionar todos</label>
                    </div>
                    <div class="mt-1">Selecionar todos los permisos para este rol</div>
                </div>
                <div class="col-md-6 justify-content-end align-items-end d-flex">
                    <div>
                        <button wire:click.prevent="store()" class="btn btn-primary me-1">Guardar</button>
                        <a class="btn btn-outline-secondary" href="{{route('seguridad.roles.list')}}">
                            Cancelar
                        </a>
                    </div>
                </div>
            </div>
            <!--/ Add role form -->
        </div>
    </div>

    <div class="row">
        @foreach ($modulos as $i => $modulo)
        <div class="col-xl-4 col-lg-4 col-md-6">
            <div class="card">
                <div class="card-body">
                    <div class="row gy-1">
                        <div class="col-12">
                            <div class="form-check form-switch">
                                <input wire:click="$emit('moduloChecked','{{ $modulo->id }}',{{$checks[$modulo->id]}})"
                                    wire:model="checks.{{$modulo->id}}" type="checkbox" class="form-check-input"
                                    id="check-{{$modulo->id}}">
                                <label class="form-check-label fw-bolder"
                                    for="check-{{$modulo->id}}">{{$modulo->nombre}}</label>
                            </div>
                        </div>
                        <div class="col-12">
                            <fieldset {{ $checks[$modulo->id] ? '' : 'disabled' }}>
                                <div class="row gy-1">
                                    <div class="col-12">
                                        <label class="form-check-label fw-bolder">Permisos disponibles:</label>
                                    </div>
                                    @foreach ($modulo->permissions as $j => $permiso)
                                    <div class="col-6">
                                        <div class="form-check form-check-inline">
                                            <input name="check-{{$modulo->id}}" wire:model="permisos"
                                                class="form-check-input" type="checkbox"
                                                id="check-{{$modulo->id}}-p-{{$permiso->id}}" value="{{$permiso->id}}">
                                            <label class="form-check-label"
                                                for="check-{{$modulo->id}}-p-{{$permiso->id}}">{{$permiso->label}}</label>
                                        </div>
                                    </div>
                                    @endforeach
                                </div>
                            </fieldset>
                        </div>

                    </div>
                </div>
            </div>
        </div>
        @endforeach
    </div>
    @section('page-script')
    <!-- Page js files -->
    <script type="text/javascript">
        document.addEventListener('livewire:load', function () {
            @this.on('moduloChecked', (modulo, value) => {
                var elementos = document.getElementsByName("check-" + modulo);
                var permisos = [];
                for (var check of elementos) {
                    permisos.push(check.value);
                }
                if (value == 1) {
                    @this.call('removePermisos', permisos);
                } else {
                    @this.call('addPermisos', permisos);
                }
            });
        })
    </script>
    @endsection
</div>

Modules/Seguridad/Resources/views/livewire/roles/delete.blade.php
<div>
    @push('scripts')
    <script type="text/javascript">
        document.addEventListener('livewire:load', function () {
            window.livewire.on('triggerDelete', model_id => {
                Swal.fire({
                    title: '¿Esta seguro?',
                    text: '¡El rol será eliminado!',
                    icon: "warning",
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#aaa',
                    confirmButtonText: 'Eliminar',
                    cancelButtonText: 'Cancelar',
                }).then((result) => {
                    //if user clicks on delete
                    if (result.value) {
                        // calling destroy method to delete
                        @this.call('destroy', model_id);
                        // success response
                        Swal.fire({ title: 'Rol eliminado correctamente!', icon: 'success' });
                    }
                });
            });
        })
    </script>
    @endpush
</div>

Modules/Seguridad/Resources/views/livewire/roles/index.blade.php
<div>
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col">
                    <div class="input-group input-group-merge">
                        <span class="input-group-text">
                            <i class="fas fa-search"></i>
                        </span>
                        <input wire:model="search" type="search" type="text" class="form-control"
                            placeholder="Búsqueda de rol">
                    </div>
                </div>
                <div class="col d-flex align-items-center justify-content-end">
                    {{$roles->links()}}
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        @foreach ($roles as $index => $rol)
        <div class="col-xl-4 col-lg-4 col-md-6">
            <div class="card">
                <div class="card-body">
                    <div class="d-flex justify-content-between">
                        <span>Total {{$rol->users_count}} usuarios</span>
                        <ul class="list-unstyled d-flex align-items-center avatar-group mb-0">
                            @foreach ($rol->sampleUsers as $user)
                            <li data-bs-toggle="tooltip" data-popup="tooltip-custom" data-bs-placement="top"
                                class="avatar avatar-sm pull-up">
                                <img class="rounded-circle" src="{{$user->profile_photo_url}}" />
                            </li>
                            @endforeach
                        </ul>
                    </div>
                    <div class="d-flex mt-1 pt-25">
                        <div class="role-heading">
                            <h4 class="fw-bolder">{{$rol->name}}</h4>
                        </div>
                    </div>
                    <div class="d-flex justify-content-end">
                        <a href="{{route('seguridad.roles.edit',['rol'=>$rol->id])}}" type="button" class="btn btn-sm
                            btn-flat-primary waves-effect">Editar</a>
                        <button class="btn btn-sm btn-flat-danger waves-effect"
                            wire:click="$emit('triggerDelete','{{ $rol->id }}')">
                            Eliminar
                        </button>
                    </div>
                </div>
            </div>
        </div>
        @endforeach
    </div>
</div>